# cpl generate

## Contents

- Description

- Arguments

- Schematics

Generate a file based on schematic.

cpl generate <schematic> <name>
cpl g <schematic> <name>
cpl G <schematic> <name>

## Description

Generates files based on a schematic.

You can define custom schematics by creating templates in a `.cpl` folder.

## Arguments

Argument | Description | Value type
--- | --- | ---
`<schematic>` | The schematic to generate. | `str`
`<name>` | The name of the generated file. | `str`
`--base` | First element of path will be used as base-path not ‘src’. For example: ‘cpl g c test/Test’ will be created at `src/test/` with –base it would be `test/` | `str`

## Schematics

Schematic | Description | Arguments
--- | --- | ---
`abc` | Abstract base class | `<name>`
`class` | Class | `<name>`
`enum` | Enum class | `<name>`
`pipe` | Pipe class | `<name>`
`service` | Service class | `<name>`
`settings` | Configmodel | `<name>`
`test` | Test class | `<name>`
`thread` | Thread class | `<name>`
`validator` | Validator class | `<name>`
`command` | Discord bot command class | `<name>`
`event` | Discord bot event class | `<name>`